import { type IType, type Opt, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrHomeworkstudent {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  HomeworkId!: IType<number, bigint>;
  StudentId!: IType<number, bigint>;
  ReviewId!: IType<number, bigint>;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  PenId?: IType<number, bigint>;
  MapStudentId?: IType<number, bigint>;
  ReadingDurationSeconds?: IType<number, bigint>;
  Status: number & Opt = 0;
}

export const IcrHomeworkstudentSchema = defineEntity({
  class: IcrHomeworkstudent,
  comment: '学生作业',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    HomeworkId: p.bigint().name('HomeworkId').columnType('bigint').comment('作业id').index('idx_ICR_HomeworkStudent_01'),
    StudentId: p.bigint().name('StudentId').columnType('bigint').comment('学生Id').index('idx_ICR_HomeworkStudent_02'),
    ReviewId: p.bigint().name('ReviewId').columnType('bigint').comment('批阅人Id'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    PenId: p.bigint().name('PenId').columnType('bigint').nullable().comment('笔Id'),
    MapStudentId: p.bigint().name('MapStudentId').columnType('bigint').nullable().comment('映射学生Id'),
    ReadingDurationSeconds: p.bigint().name('ReadingDurationSeconds').columnType('bigint').nullable().comment('阅读时间'),
    Status: p.integer().name('Status').comment('状态(0:默认 1:已校验)'),
  },
});
